//
//  GMCalloutController.m
//  GIS
//
//  Created by Hamza Haroon on 12-09-04.
//  Copyright (c) 2012 Aecom. All rights reserved.
//

#import "GMCalloutController.h"

@interface GMCalloutController ()

@end

@implementation GMCalloutController
@synthesize results;// = _results;
@synthesize tableView;// = _tableView;

-(void)viewDidLoad
{
    [super viewDidLoad];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"CurrentViewChanged" object:self];


    self.tableView.delegate = self;
    self.tableView.dataSource = self;
}

- (IBAction)done:(id)sender
{
    [self dismissModalViewControllerAnimated:YES];
}

#pragma mark -
#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    //if results is not nil and we have results, return that number
    return ((self.results != nil && [self.results count] > 0) ? [self.results count] : 0);
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Set up the cell...
    
    //text is the key at the given indexPath
    NSString *keyAtIndexPath = [[self.results allKeys] objectAtIndex:indexPath.row];
    cell.textLabel.text = keyAtIndexPath;
    
    //detail text is the value associated with the key above
    id detailValue = [self.results objectForKey:keyAtIndexPath];
    
    //figure out if the value is a NSDecimalNumber or NSString
    if ([detailValue isKindOfClass:[NSString class]])
    {
        //value is a NSString, just set it
        cell.detailTextLabel.text = (NSString *)detailValue;
    }
    else if ([detailValue isKindOfClass:[NSDecimalNumber class]])
    {
        //value is a NSDecimalNumber, format the result as a double
        cell.detailTextLabel.text = [NSString stringWithFormat:@"%0.0f", [detailValue doubleValue]];
    }
    else {
        //not a NSDecimalNumber or a NSString,
        cell.detailTextLabel.text = @"N/A";
    }
	
    return cell;
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (YES);
}

- (void)dealloc {
    [super dealloc];
    
    self.results = nil;
    self.tableView = nil;
}


@end

 