//
//  GMLegendController.m
//  GIS
//
//  Created by Hamza Haroon on 12-09-06.
//  Copyright (c) 2012 Aecom. All rights reserved.
//

#import "GMLegendController.h"

@implementation GMLegendController

@synthesize legendInfotodisplay;
@synthesize legendDataSource;
@synthesize indexSet;
@synthesize transparencySwitch;
@synthesize dynamicLayer;
@synthesize delegate;



- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"CurrentViewChanged" object:self];

    legendDataSource = [[GMLegendDataSource alloc] init];// autorelease];
    dynamicLayer = [[AGSDynamicMapServiceLayer alloc] init];
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
    currentLayerID = 0;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [[NSNotificationCenter defaultCenter] postNotificationName:@"CurrentViewChanged" object:self];

    [super viewDidAppear:animated];
    
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//Number of legend items we have
    return [[legendDataSource legendInfos] count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSInteger indexRow = indexPath.row;
        
    NSString *CellIdentifier = [NSString stringWithFormat:@"Cell%d", indexRow]; //this is where each cell gets  unique identifier which prevents any problems
    //can't reuse cells because of problems with custom switch control redrawing
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    // Configure the cell...
	// Set up the cell with the legend image, text, and detail
	LegendInfo *legendInfo = [self.legendDataSource.legendInfos objectAtIndex:indexRow];
    LegendInfo *prevInfo;
    
    NSMutableArray *tempIDs = [[[NSMutableArray alloc] init] autorelease];
    for (int i= 0; i < [self.legendDataSource.visibleIcons count]; i++)
    {
        AGSLayerDefinition *tempDef = [self.legendDataSource.visibleIcons objectAtIndex:i];
        NSString *temp = [NSString stringWithFormat:@"%d", tempDef.layerId];
        [tempIDs addObject:temp];
    }
    
    
   
    if (legendInfo.image == nil) {
      cell = nil;
    cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    //	cell.detailTextLabel.text = legendInfo.detail;
    cell.detailTextLabel.text = legendInfo.detail;
    cell.textLabel.font = [UIFont systemFontOfSize:12.0];
    
    if (legendInfo.name == nil) {
        cell.textLabel.text = legendInfo.detail;
    }
    else
        cell.textLabel.text = legendInfo.name;
    
    cell.imageView.image = legendInfo.image;

    if (legendInfo.layerID == 0)
    {
        self.transparencySwitch = [[UISwitch alloc] initWithFrame:CGRectMake(230, 10, 100, 20)];
        NSString *tempID = [NSString stringWithFormat:@"%d", (int)legendInfo.layerID ];

        if (![tempIDs containsObject:tempID]) {
            self.transparencySwitch.on = ([[self.legendDataSource.legendInfos objectAtIndex:indexRow]visible] == YES);
        }
        
        [self.transparencySwitch addTarget:self action:@selector(layerTransparencySwitchUpdated:) forControlEvents:UIControlEventValueChanged];
        
        [cell addSubview:self.transparencySwitch];
    }
    
    if (indexRow >= 1) { // if this is not a child row, add a switch control Transparency Switch
        prevInfo = [self.legendDataSource.legendInfos objectAtIndex:indexRow-1];
        
        if (legendInfo.layerID != prevInfo.layerID)// || legendInfo.layerID == 0)
        {
            self.transparencySwitch = [[UISwitch alloc] initWithFrame:CGRectMake(230, 10, 100, 20)];
            NSString *tempID = [NSString stringWithFormat:@"%d", (int)legendInfo.layerID ];
            
            if (![tempIDs containsObject:tempID]) {
                self.transparencySwitch.on = ([[self.legendDataSource.legendInfos objectAtIndex:indexRow]visible] == YES);
            }
            
            [self.transparencySwitch addTarget:self action:@selector(layerTransparencySwitchUpdated:) forControlEvents:UIControlEventValueChanged];
            
            [cell addSubview:self.transparencySwitch];
        }
    }

    return cell;    
}

-(IBAction)layerTransparencySwitchUpdated:(UISwitch *)sender {
    
    UITableViewCell *cell = (UITableViewCell *)[sender superview];
	NSIndexPath* path = [self.legendTableView indexPathForCell:(UITableViewCell *)[sender superview]];
    
    // NSLog(@"Clicked on table row %d which is index row %@", path.row, indexRow);
    LegendInfo *info = [self.legendDataSource.legendInfos objectAtIndex:path.row];
    NSString *def = info.detail;
    int layerID = (int)info.layerID;

    AGSLayerDefinition *layerDef = [AGSLayerDefinition layerDefinitionWithLayerId:layerID definition:def];


    if (sender.on)
    {
        info.visible = YES;
        for (int i= 0; i < [self.legendDataSource.visibleIcons count]; i++) {
            AGSLayerDefinition *temp = [self.legendDataSource.visibleIcons objectAtIndex:i];
          
            if ([temp.definition isEqualToString:info.detail])
            {
                [self.legendDataSource.visibleIcons removeObjectAtIndex:i];
            }
        }
    }
    else{
        info.visible = NO;
        [self.legendDataSource.visibleIcons addObject:layerDef];
    }
    
    
    [cell setNeedsLayout];
    [self.legendDataSource reload];
    [[self delegate]reloadMap:self.legendDataSource.visibleIcons];

    
}
 
/*
 // Override to support conditional editing of the table view.
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */

/*
 // Override to support editing the table view.
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
 {
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
 }
 else if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }
 }
 */

/*
 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
 }
 */

/*
 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
}

@end
