//
//  GMLegendDataSource.h
//  GIS
//
//  Created by Hamza Haroon on 12-09-07.
//  Copyright (c) 2012 Aecom. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <ArcGIS/ArcGIS.h>



@interface GMLegendDataSource : NSObject <AGSMapServiceInfoDelegate>
{
	UITableView* _tableView;
	NSMutableArray* _legendInfos;
    NSMutableArray* _layerMgmInfos;
    NSMutableArray* _visibleIcons;
}
@property (nonatomic, retain) NSMutableArray* legendInfos;
@property (nonatomic, retain) NSMutableArray* visibleIcons;
@property (nonatomic, retain) AGSDynamicMapServiceLayer *dynamicLayer;

- (id) init;
- (void) reload;
- (void) addLegendForLayer:(AGSLayer*)layer;

@end


@interface LegendInfo : NSObject {
@protected
    NSString *_name;
    UIImage *_image;
	NSString *_detail;
    NSUInteger *_layerID;
}

@property (nonatomic,retain) NSString *name;
@property (nonatomic,retain) NSString *detail;
@property (readwrite,retain) UIImage *image;
@property (nonatomic, retain) UIView *view;
@property (nonatomic) NSUInteger *layerID;
@property (readwrite) BOOL visible;
@end