//
//  GMViewController.h
//  GIS
//
//  Created by Hamza Haroon on 12-08-24.
//  Copyright (c) 2012 Aecom. All rights reserved.
//

#define kTiledMapServiceURL1 @"http://server.arcgisonline.com/ArcGIS/rest/services/NatGeo_World_Map/MapServer"

#define kDynamicMapServiceURL1  @"http://sampleserver1.arcgisonline.com/ArcGIS/rest/services/Demographics/ESRI_Census_USA/MapServer"


#import <UIKit/UIKit.h>
#import <ArcGIS/ArcGIS.h>
#import "GMCalloutController.h"
#import "GMLegendController.h"
#import "GMLegendDataSource.h"
#import <MessageUI/MessageUI.h>
#import <QuartzCore/QuartzCore.h>

@interface GMViewController : UIViewController <AGSMapViewLayerDelegate, AGSMapViewCalloutDelegate, AGSIdentifyTaskDelegate, AGSMapViewTouchDelegate, AGSInfoTemplateDelegate, UISearchBarDelegate,
 UIPopoverControllerDelegate, AGSFindTaskDelegate, MFMailComposeViewControllerDelegate,  legendDelegate>

{
    AGSMapView *_mapView;
    UIToolbar* _toolbar;
    IBOutlet UISlider *brush;
    AGSMutablePolyline *poly;
    NSMutableArray *polyLines;
    AGSIdentifyTask *_identifyTask;
    AGSIdentifyParameters *_identifyParams;
    AGSPoint* _mappoint;
    NSDictionary *resultsVC;
    GMLegendDataSource* _legendDataSource;
    GMLegendController* _legendViewController;
    NSMutableArray *legendInformation;
    
    UIPopoverController* activePopover;
    
}

@property (nonatomic, retain) IBOutlet UISearchBar *searchBar;
@property (nonatomic, retain) AGSFindTask *findTask;
@property (nonatomic, retain) AGSFindParameters *findParams;
@property (nonatomic, retain) AGSGraphicsLayer *graphicsLayer3;

@property (nonatomic, retain) UIPopoverController *popOverController;

@property (nonatomic, retain) GMLegendDataSource *legendDataSource;

//button to show legend
- (IBAction)showLegend:(id)sender;

@property (nonatomic, retain) UIView *dynamicLayerView;
@property (nonatomic, retain) UIView<AGSLayerView> *backgroundLayerView;

@property (nonatomic, retain) NSDictionary *resultsVC;
@property (nonatomic, retain) NSMutableArray *visibleLegend;

@property (strong, nonatomic) IBOutlet AGSMapView *mapView;
@property (nonatomic, retain) AGSTiledMapServiceLayer *tiledLayer;
@property(nonatomic, retain) AGSDynamicMapServiceLayer *dynamicLayer;
@property (nonatomic, retain) AGSSketchGraphicsLayer *sketchLayer;
@property (nonatomic, retain) AGSSketchGraphicsLayer *sketchLayer2;
@property (nonatomic, retain) AGSGraphicsLayer *graphicsLayer;
@property (nonatomic, retain) AGSGraphicsLayer *graphicsLayer2;

@property (nonatomic, retain) AGSMarkerSymbol *midSymbol;
@property (nonatomic, retain) AGSMarkerSymbol *vertSymbol;

@property (nonatomic, retain) AGSIdentifyTask *identifyTask;
@property (nonatomic, retain) AGSIdentifyParameters *identifyParams;
@property (nonatomic, retain) AGSPoint* mappoint;

@property (nonatomic, retain) AGSCredential *cred;
@property (nonatomic,retain) IBOutlet UIToolbar* toolbar;

@end
